const { LogType } = require("loguix")
const fs = require("fs")
const path = require("path")
const { __glob } = require("./global-variables")
const clog = new LogType("Fichier")
const os = require("os");
const uuid = require('uuid');
var mime = require('mime-types');

module.exports.getFiles = function(root) {

    var response = new Object()
    response.content = new Array()
    response.root = root
    response.parent = path.dirname(root)


    try{

        if(root == "homepath") {

            root = os.homedir()
            response.root = root
           
        }

        
        if(!fs.existsSync(root)) {
           response.content = "NOT_EXIST" 
        
        } else {
            
            for(var file of fs.readdirSync(root)) {
    
                const stat = fs.statSync(root + path.sep + file)
                                  
                response.content.push({"name":file, id: uuid.v4().toString() ,"fileDirectory" : root + path.sep + file  , "type":mime.lookup(file), "size":stat.size, "lastedition":stat.mtimeMs, "directory":stat.isDirectory()})
            }
            
        }

       

       
        
    }catch(err) {

        response.content = "NOT_PERMITTED"
    }

    return response
   
}